var y pii;

varexo rr ii ;

parameters NZLB pi_star rho sigma beta potential_gdp_growth one_minus_alpha phi epsilon theta nat_int_rate aux_const lambda Beta Pi Phi Alpha A Theta Sigma_inverted Omega Beta_pi Kappa_1 Delta_pi Beta_1 Beta_2 Kappa_2 alpha kappa;

@#include "NZLB.mod"
pi_star=(1.02)^(1/4); //gross steady state inflation, in quarterly terms
sigma=0.157; //intertemporal elasticity of substitution, Woodford (1999)
beta=0.99; //households' discount factor (impatience), Woodford (1999)
potential_gdp_growth=0.02; //matching long-term real per capita gdp growth in the US economy
one_minus_alpha=0.7; //Cobb-Douglas exponent on labour, Smets Wouters (2002)
phi=0.25; //elasticity of labour supply, Smets Wouters (2003)
epsilon=1.5; //elasticity of substitution between labour varieties, Smets Wouters (2002)
theta=0.794071964049275; //find_theta(0.024,beta,one_minus_alpha,phi,epsilon,sigma); //Calvo probability, set so as to match Woodford's kappa=0.024 under the rest given 
nat_int_rate=sigma*potential_gdp_growth/4+(1-beta)*beta;
aux_const=((pi_star+1)^(epsilon-1))*((pi_star+1)^(1-epsilon)-theta)^(-epsilon/(1-epsilon))*(1-theta)^(1/(1-epsilon));
lambda = ((1-beta*theta)*aux_const^2)/(1-theta-aux_const^2)*(phi+sigma)/epsilon;
alpha=1-one_minus_alpha;
kappa=((1-theta)*(1-beta*theta))/(theta)*(1-alpha)/(1-alpha+alpha*epsilon+phi*epsilon)*(sigma+(phi+alpha)/(1-alpha));

Beta=beta;
Pi=pi_star;
Phi=phi;
Alpha=theta;
A=one_minus_alpha;
Theta=epsilon;
Sigma_inverted=sigma;
Omega = (1+Phi-A)/A;

Beta_pi = Beta*((1-Alpha*(Pi^(Theta-1)))*(((Theta+Omega*Theta)/(1+Omega*Theta))*(Pi^(1+Omega*Theta))-(Theta-1)/(1+Omega*Theta))+Alpha*(Pi^(Theta+Omega*Theta)));
Kappa_1 = ((1-Alpha*(Pi^(Theta-1)))*(1-Alpha*Beta*(Pi^(Theta+Omega*Theta))))/(Alpha*(Pi^(Theta-1)))*(Omega+Sigma_inverted)/(1+Omega*Theta)+(Beta*(1-Alpha*(Pi^(Theta-1)))*(1-Pi^(1+Omega*Theta)))/(1+Omega*Theta);
Delta_pi = ((Pi^(1+Omega*Theta)-1)*Beta*(1-Alpha*(Pi^(Theta-1)))*(1-Alpha*Beta*(Pi^(Theta-1))))/(1+Omega*Theta);

Beta_1 = Beta_pi + Alpha*Beta*(Pi^(Theta-1));
Beta_2 = -Alpha*(Beta^2)*(Pi^(Theta+Omega*Theta));
Kappa_2 = Delta_pi - Alpha*Beta*(Pi^(Theta-1))*Kappa_1;


model;

y = y(+1)-1/sigma*(ii-pii(+1)-rr);
pii = Beta_1*pii(+1)+Beta_2*pii(+2)+Kappa_1*y+Kappa_2*y(+1);
//rr = rho*rr(-1)+eps_r;
//ii = -(nat_int_rate+pi_star-1)+NZLB;

end;

initval;
@#include "initval_list.mod"
end;

endval;
pii=0;
y=0;
end;

shocks;
@#include "shock_list.mod"
end;

//steady;

@#include "per.mod"

dynasave('wyniki_deterministyczne.mat') y pii;