function [y_p, ii_p, rr_p, pi_p, phi1_p, phi2_p] = PLB_runsim_newkeynesian(SHOCKS,NZLB,rho,nat_int_rate,pi_star)

%% set inputs for solution below
%  The program produces responses to the shocks selected below under
%  irfshock. Paths for all the endogenous variables in the model selected
%  are produced. VariableName_difference holds the piece-wise linear solution for
%  VariableName.  VariableName_uncdifference holds the linear solution for
%  VariableName.


global M_ oo_

modnam = 'PLB_fv';
modnamstar = 'PLB_fv_zlb';

constraint = 'rr+pi_star<NZLB';
constraint_relax ='rr+pi_star>NZLB';

% Pick innovation for IRFs
irfshock = char('eps_r');      % label for innovation for IRFs

maxiter = 40;
tol0 = 1e-6;
%firstval=[0 0.0156479 0 0.010685 0 0];
firstval=[0 0 0 0];





% Solve nonlinear model




shockssequence = SHOCKS;
nperiods = size(SHOCKS,1);

delete('NZLB.mod');
fid = fopen('NZLB.mod', 'w');
fprintf(fid, ['NZLB = ' num2str(NZLB) '; \n rho = ' num2str(rho) ';']);
fclose(fid);

% Solve model, generate model IRFs
[zdatalinear zdatapiecewise zdatass oobase_ Mbase_  ] = ...
  solve_one_constraint(modnam,modnamstar,...
  constraint,constraint_relax,...
  shockssequence,irfshock,nperiods,maxiter,firstval);


% unpack the IRFs                          
for i=1:M_.endo_nbr
  eval([deblank(M_.endo_names(i,:)),'_u=zdatalinear(:,i);']);
  eval([deblank(M_.endo_names(i,:)),'_p=zdatapiecewise(:,i);']);
  eval([deblank(M_.endo_names(i,:)),'_ss=zdatass(i);']);
end

%% Bring back constants
rr_p = rr_p+nat_int_rate;
pi_p = pi_p+pi_star-1;
ii_p = ii_p+nat_int_rate+pi_star-1;








