function [loss]=compute_loss(NZLB,rho)

nat_int_rate = 0.010685;
pi_star = 1.0050;
load '../shocks.mat';
SHOCKS=SHOCKS2;

delete('NZLB.mod');
fid = fopen('NZLB.mod', 'w');
fprintf(fid, ['NZLB = ' num2str(NZLB) '; \n rho = ' num2str(rho) ';']);
fclose(fid);

rr=zeros(size(SHOCKS,1),1);
rr(1,1)=SHOCKS(1,1);
for jj=2:size(SHOCKS,1)
        rr(jj,1)=rho*rr(jj-1,1)+SHOCKS(jj,1);
end
rr=rr+nat_int_rate*ones(size(SHOCKS,1),1);
LB=((rr+(pi_star-1)*ones(size(SHOCKS,1),1))<ones(size(SHOCKS,1),1)*NZLB);

LB_series=NaN(0,2);
prev=0;
local_length=0;
first=0;

for kk=1:size(LB,1)
    now=LB(kk,1);
    if now==1 && prev==0
        local_length=1;
        first=kk;
    end
    if now==1 && prev==1
        local_length=local_length+1;
    end
    if now==0 && prev==1
        LB_series=[LB_series; first, local_length];
        local_length=0;
    end
    prev=now;
end

zmienne_endo=zeros(4,size(SHOCKS,1));
for ll=1:size(LB_series,1)
    for mm=1:LB_series(ll,2)
        
        %we ze zmienne_endo wektor zmiennych endo dla ll+mm-2 i wydrukuj jako initval
        delete initval_list.mod
        fid = fopen('initval_list.mod', 'w');
        fprintf(fid, ['y = ' num2str(zmienne_endo(1,LB_series(ll,1)+mm-2)) '; \n pii = ' num2str(zmienne_endo(2,LB_series(ll,1)+mm-2)) '; \n']);
        fclose(fid);
        
        %zlicz do kiedy potrwa ograniczenie (przez rho)
        rr_now=rr(mm+LB_series(ll,1)-1,1)-nat_int_rate;
        per=0;
        while rr_now+nat_int_rate+(pi_star-1)<NZLB
            per=per+1;
            rr_now=rho*rr_now;
        end
        
%         %wydrukuj endval
%         delete endval_list.mod
%         fid2 = fopen('endval_list.mod', 'w');
%         fprintf(fid2, ['y = ' num2str(0) '; \n pi = ' num2str(0) ';']);
%         fclose(fid2);
        
        %wydrukuj mm-ty szok jako shocks (jeden)
        delete shock_list.mod
        fid3 = fopen('shock_list.mod', 'w');
        fprintf(fid3, ['var ii; \n periods 1:' num2str(per) '; \n values ' num2str(-(nat_int_rate+pi_star-1)+NZLB) ';\n']);
        fprintf(fid3, 'var rr; \n');
        rr_path=NaN(per+1,1);
        rr_path(1,1)=rr(LB_series(ll,1)+mm-2,1)-nat_int_rate;
        rr_path(2,1)=rho*rr_path(1)+SHOCKS(LB_series(ll,1)+mm-1);
        for qq=1:(per-1)
            rr_path(qq+2,1)=rho*rr_path(qq+2-1,1);
        end
        fprintf(fid3, 'periods');
        for nn=1:per
            fprintf(fid3, [' ' num2str(nn)]);
        end
        fprintf(fid3, ';\n');
        fprintf(fid3, 'values');
        for nn=1:per
            fprintf(fid3, [' ' num2str(rr_path(nn+1,1))]);
        end
        fprintf(fid3, ';\n');
        fclose(fid3);
        
        %wydrukuj liczb okresw symulacji
        delete per.mod
        fid4 = fopen('per.mod', 'w');
        fprintf(fid4, ['simul(periods=' num2str(per) ');']);
        fclose(fid4);
        
        save('workspace.mat','zmienne_endo','ll','mm','LB_series','SHOCKS','rr');
        dynare PLB_fv_zlb
        load('workspace.mat');
        load('wyniki_deterministyczne.mat');
        
        %wpisz zmienne do kolumny ll+mm-1 macierzy zmienne_endo
        zmienne_endo(1,LB_series(ll,1)+mm-1)=y(2,1);
        zmienne_endo(2,LB_series(ll,1)+mm-1)=pii(2,1);
    end
end


pii=zmienne_endo(2,:)';
y=zmienne_endo(1,:)';
loss = var(pii)+(1.446908808825777e-04)*var(y);%lambda
